package eu.jonahbauer.raytracing;

import eu.jonahbauer.raytracing.material.LambertianMaterial;
import eu.jonahbauer.raytracing.render.Camera;
import eu.jonahbauer.raytracing.render.Color;
import eu.jonahbauer.raytracing.render.ImageFormat;
import eu.jonahbauer.raytracing.scene.Scene;
import eu.jonahbauer.raytracing.scene.Sphere;

import java.io.IOException;
import java.nio.file.Path;

public class Main {
    public static void main(String[] args) throws IOException {
        var scene = new Scene(
                new Sphere(0, 0, 1, 0.5, new LambertianMaterial(Color.RED)),
                new Sphere(0, -100.5, 1, 100, new LambertianMaterial(Color.BLUE))
        );
        var camera = new Camera(512, 2, 16 / 9d);

        var image = camera.render(scene);
        ImageFormat.PNG.write(image, Path.of("scene-" + System.currentTimeMillis() + ".png"));
    }
}